#!/bin/bash

T_TEX="a064b0d59b255f395401c03869d3b664e8ea26e946cf00d9e00d4a3cc1da7d04"

failed=""

clean() {
  rm -f thesis*
}

test_from_file_to_zip_to_file() {
  clean
  cp -a test/thesis.tex .
  ./sat thesis.tex -o gz thesis.tex.tar.gz
  rm thesis.tex
  ./sat -i gz thesis.tex.tar.gz . &> /dev/null

  if ! sha256sum thesis.tex | grep "$T_TEX"; then
    echo "$0 failed"
    failed="true"
  else
    echo "$0 ok"
  fi
}

test_from_file_to_tar_to_file() {
  clean
  cp -a test/thesis.tex .
  ./sat thesis.tex -o tar thesis.tex.tar
  rm thesis.tex
  ./sat -i tar thesis.tex.tar . &> /dev/null

  if ! sha256sum thesis.tex | grep "$T_TEX"; then
    echo "$0 failed"
    failed="true"
  else
    echo "$0 ok"
  fi
}


test_from_file_to_tar_to_file
test_from_file_to_zip_to_file

RED="\033[31m\033[1m"
GREEN="\033[32m\033[1m"
BLUE="\033[34m\033[1m"
CLEAR="\033[0m"
if [ -n "$failed" ]; then
  echo -e "${RED}failed${CLEAR}"
  exit 1
else
  echo -e "${GREEN}ok${CLEAR}"
fi
